# Source

Sources have been downloaded from vtk official github and correspond to commit 6327999 [VTK 8.1.0](https://github.com/Kitware/VTK).

# Build

## Linux

Before building, you must install additional dependencies, as root:
```
#yum install -y libXt-devel
```

Then follow the same procedure as for Windows platform.

## Debian 9

```
cmake -B debian9-gcc6-release-shared -G Ninja -DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=ON -DVTK_RENDERING_BACKEND=OpenGL2 -DModule_vtkRenderingExternal=ON -DModule_vtkxdmf2=ON -DModule_vtkxdmf3=ON -DModule_vtkIOXdmf2=ON -DModule_vtkIOXdmf3=ON -DBUILD_TESTING=OFF -DCMAKE_INSTALL_PREFIX=/opt/nf-libs/vtk-8.1.0/debian9-gcc6-release-shared
ninja -C debian9-gcc6-release-shared install
```

## Windows

The goal is to substute Vtk rendering by Qml, for that Module_vtkRenderingExternal=ON is necessary.
Vtk provides two types of rendering engines, one based on deprecated OpenGL (OpenGL <= 1.4) and other on modern OpenGL (>3.3). Qml rendering is based on modern OpenGL, for that we wil use VTK_RENDERING_BACKEND=OpenGL2.
Build testing need glut dependency, to avoid it we use BUILD_TESTING=OFF.

Go to source directory and type:
```
# mkdir build-${NF_PLATFORM}
# cd build-${NF_PLATFORM}
# cmake .. -G "Ninja" -DVTK_RENDERING_BACKEND=OpenGL2 -DModule_vtkRenderingExternal=ON -DModule_vtkxdmf2=ON -DModule_vtkxdmf3=ON -DModule_vtkIOXdmf2=ON -DModule_vtkIOXdmf3=ON -DBUILD_TESTING=OFF "-DCMAKE_INSTALL_PREFIX=${NF_LIBS}/vtk-8.1.0/${NF_PLATFORM}-${NF_COMPILER}-release-shared" "-DBUILD_SHARED_LIBS=ON" "-DCMAKE_BUILD_TYPE=Release"
# ninja
# ninja install
# cmake .. -G "Ninja" -DVTK_RENDERING_BACKEND=OpenGL2 -DModule_vtkRenderingExternal=ON -DModule_vtkxdmf2=ON -DModule_vtkxdmf3=ON -DModule_vtkIOXdmf2=ON -DModule_vtkIOXdmf3=ON -DBUILD_TESTING=OFF "-DCMAKE_INSTALL_PREFIX=${NF_LIBS}/vtk-8.1.0/${NF_PLATFORM}-${NF_COMPILER}-debug-shared" "-DBUILD_SHARED_LIBS=ON" "-DCMAKE_BUILD_TYPE=Debug"
# ninja
# ninja install
```

